﻿using JetBrains.Annotations;
using TamiFlu.Core.Simulation.SystemSolver;
using TamiFlu.Interfaces.Simulation;
using TamiFlu.Interfaces.Simulation.Solver;

namespace TamiFlu.Core.Simulation.Solver.Boundary
{
    internal interface IIterativeBoundaryHandling : IBoundaryHandling
    {
        #region Methods

        [NotNull] ComputeDiagonalElements CreateComputeDiagonalElementFunc([NotNull] IParticleContext particleContext);

        [NotNull] ComputeSourceTerms CreateComputeSourceTermFunc([NotNull] IParticleContext particleContext);

        [NotNull] InitializeVector CreateInitializeVectorFunc([NotNull] IParticleContext particleContext, float factor);

        [NotNull] ComputeMatrixVectorProduct CreateComputeMatrixVectorProductFunc([NotNull] IParticleContext particleContext, [NotNull] ref Vector[] pressureAccelerations);

        #endregion
    }
}
