﻿#region Copyright
// Copyright (c) 2017 Stefan Band <bands@informatik.uni-freiburg.de>
//  
// Permission to use, copy, modify, and/or distribute this software for any purpose with or without fee is hereby granted, 
// provided that the above copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE
// INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE
// FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
// LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, 
// ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#endregion
using System;
using JetBrains.Annotations;

namespace TamiFlu.Interfaces
{
    public sealed class PluginAttribute : Attribute
    {
        #region Properties

        [NotNull] public string Name { get; }

        [NotNull] public string Version { get; }

        [NotNull] public string Author { get; }

        public bool Visible { get; }

        #endregion

        #region Constructor

        public PluginAttribute([NotNull] string name, [NotNull] string version, [NotNull] string author, bool visible = true)
        {
            Name = name;
            Version = version;
            Author = author;
            Visible = visible;
        }

        #endregion
    }
}
