﻿#region Copyright
// Copyright (c) 2017 Stefan Band <bands@informatik.uni-freiburg.de>
//  
// Permission to use, copy, modify, and/or distribute this software for any purpose with or without fee is hereby granted, 
// provided that the above copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE
// INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE
// FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
// LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, 
// ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#endregion
using System.Windows.Forms;
using Eto.WinForms.Forms;
using TamiFlu.Core.UI;

namespace TamiFlu.Windows
{
    internal sealed class WinFormsPropertyEditorHandler : WindowsControl<PropertyGrid, PropertyEditorControl, PropertyEditorControl.ICallback>, PropertyEditorControl.IPropertyEditorHandler
    {
        #region Constructor

        public WinFormsPropertyEditorHandler()
        {
            Control = new PropertyGrid();
        }

        #endregion

        #region Implementation of PropertyEditorControl.IPropertyEditorHandler

        /// <inheritdoc />
        public object SelectedObject
        {
            get => Control.SelectedObject;
            set
            {
                Control.SelectedObject = value;
                Control.ExpandAllGridItems();
            }
        }

        #endregion
    }
}
